//+------------------------------------------------------------------+
//|                        bollitoucher_alerts+mtf nmc for Keith.mq4 |
//|                     property of janus2122@exemail.com.au                       |
//|                      |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "property of janus2122@exemail.com.au"
#property version   "1.01"
#property indicator_chart_window
#property indicator_buffers 11
#property  indicator_color1 SlateBlue
#property  indicator_color2 SlateBlue
#property  indicator_color3 LightBlue
#property  indicator_color4 Pink

#property  indicator_color7 clrRed
#property  indicator_color8 clrRed
#property  indicator_color9 clrRed
#property  indicator_color10 clrRed
#property  indicator_color11 clrYellow

//extern string ______1st_BB_____     = "==============================";
extern string TimeFrame             = "0";
extern int    BollPeriod            = 20;
extern int    BollMethod            = 0;
extern int    BollPrice             = 0;
extern double BollDeviation         = 2.0;
extern string ______2nd_BB_____     = "==============================";
extern bool   Display_2nd_BB        = true;
extern string _2nd_TimeFrame        = "0";
extern int    _2nd_BollPeriod       = 20;
extern int    _2nd_BollMethod       = 0;
extern int    _2nd_BollPrice        = 0;
extern double _2nd_BollDeviation    = 4.0;
extern string _____BB_width_____    = "==============================";
extern bool   DisplayBB_width_dots  = true;
extern bool   Run_it_For_inner_BB   = true;
extern int    Period_of_Normal_width_average= 0;
extern string _____alerts_____      = "==============================";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnHighLow = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsSound_narrower_wider= false;

double upBand[];
double dnBand[];
double upArrow[];
double dnArrow[];
double trend[];

double mdBand[];
double mdBand2[];
double upBand2[];
double dnBand2[];
double narrower_NORMAL[];
double wider_NORMAL[];

double WIDTH;
double NORMAL_WIDTH;
string alertsSound_narrower_wider_Time=0;

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;
color mdbbClo = LightBlue;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   EventSetTimer(1) ;
   IndicatorBuffers(11);
   SetIndexBuffer(0,upBand);
   SetIndexBuffer(1,dnBand);
   SetIndexBuffer(2,upArrow); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2, 167);
   SetIndexBuffer(3,dnArrow); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3, 167);
   SetIndexBuffer(4,trend); 
   
   SetIndexBuffer(5,mdBand); SetIndexStyle(5,DRAW_LINE,0,0,mdbbClo);
   SetIndexBuffer(6,mdBand2);
   SetIndexBuffer(7,upBand2);
   SetIndexBuffer(8,dnBand2);
   SetIndexBuffer(9,narrower_NORMAL); SetIndexStyle(9,DRAW_ARROW); SetIndexArrow(9, 167);
   SetIndexBuffer(10,wider_NORMAL);    SetIndexStyle(10,DRAW_ARROW); SetIndexArrow(10, 167);

   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  bollitoucher ");
   ButtonCreateS("MD_BB","MD_BB",55,5,15,50,CORNER_RIGHT_UPPER,8);

   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   EventKillTimer();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long& lparam,const double& dparam,const string& sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK  && sparam =="MD_BB")
     {
      if(mdbbClo == LightBlue)
        {
         mdbbClo=clrNONE;
        }else
           {
            mdbbClo = LightBlue;
           }
      SetIndexStyle(5,DRAW_LINE,0,0,mdbbClo);     
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           if (returnBars)  { upBand[0] = limit+1; return(0); }
//---
   if (calculateValue )//|| timeFrame==Period()
   {
             
   for(i = limit; i >= 0; i--)
   {
      double sum  = 0.0;
      double  ma  = iMA(NULL,0,BollPeriod,0,BollMethod,BollPrice,i);
//---
      for(j=0; j<BollPeriod; j++)
      {
      double pr  = iMA(NULL,0,1,0,MODE_SMA,BollPrice,i+j);
             sum+=(pr-ma)*(pr-ma);
      }
      double StdDev = MathSqrt(sum/BollPeriod);
//---
      mdBand[i] = ma;
      upBand[i] = ma + (StdDev*BollDeviation);
      dnBand[i] = ma - (StdDev*BollDeviation);
      
      upArrow[i]  = EMPTY_VALUE;
      dnArrow[i]  = EMPTY_VALUE; 


      if (High[i] > upBand[i]) dnArrow[i] = High[i] + iATR(NULL,0,20,i)/2.0;
      if ( Low[i] < dnBand[i]) upArrow[i] = Low[i]  - iATR(NULL,0,20,i)/2.0;
      
         trend[i] = 0;                     
            if (alertsOnHighLow)       
            {
               if (High[i] > upBand[i]) trend[i] = -1;
               if (Low[i]  < dnBand[i]) trend[i] =  1;
            }
            else
            {
               if (Close[i] > upBand[i]) trend[i] = -1;
               if (Close[i] < dnBand[i]) trend[i] =  1;
            }
      }
      
      if (!calculateValue) manageAlerts();
    return(0);
    }
//--- 
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          mdBand[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BollPeriod,BollMethod,BollPrice,BollDeviation,5,y);
          upBand[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BollPeriod,BollMethod,BollPrice,BollDeviation,0,y);
          dnBand[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BollPeriod,BollMethod,BollPrice,BollDeviation,1,y);
          trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BollPeriod,BollMethod,BollPrice,BollDeviation,4,y);
          upArrow[i] = EMPTY_VALUE;
          dnArrow[i] = EMPTY_VALUE; 
          if (High[i] > upBand[i]) dnArrow[i] = High[i]+iATR(NULL,0,20,i)/2.0;
          if ( Low[i] < dnBand[i]) upArrow[i] = Low[i] -iATR(NULL,0,20,i)/2.0;
//---
      if(Run_it_For_inner_BB)
        {
         NORMAL_WIDTH =0;
         WIDTH=0;
         WIDTH = upBand[i]-dnBand[i];
         for(int n=i;n<i+Period_of_Normal_width_average+1;n++)
           {
            NORMAL_WIDTH = NORMAL_WIDTH+upBand[n+1]-dnBand[n+1] ;
           }
         NORMAL_WIDTH = NORMAL_WIDTH/(Period_of_Normal_width_average+1);
         if(DisplayBB_width_dots && WIDTH<NORMAL_WIDTH)     {narrower_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;  wider_NORMAL[i]=EMPTY_VALUE;}else
         if(DisplayBB_width_dots && WIDTH>NORMAL_WIDTH)    {wider_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;     narrower_NORMAL[i]=EMPTY_VALUE;}
         else {wider_NORMAL[i]=wider_NORMAL[i+1];  narrower_NORMAL[i]=narrower_NORMAL[i+1];}
         if(DisplayBB_width_dots && alertsSound_narrower_wider_Time!=Time[0] && i==0 && narrower_NORMAL[0]!= narrower_NORMAL[1])
           {
            if (alertsSound_narrower_wider) PlaySound("alert2.wav");
            alertsSound_narrower_wider_Time=Time[0];
           }
        }

//---
     }
//---
   if(Display_2nd_BB)
   {
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,_2nd_TimeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
      {
       int y2 = iBarShift(NULL,_2nd_TimeFrame,Time[i]);
       mdBand2[i]  = iCustom(NULL,_2nd_TimeFrame,indicatorFileName,"calculateValue",_2nd_BollPeriod,_2nd_BollMethod,_2nd_BollPrice,_2nd_BollDeviation,5,y2);
       upBand2[i]  = iCustom(NULL,_2nd_TimeFrame,indicatorFileName,"calculateValue",_2nd_BollPeriod,_2nd_BollMethod,_2nd_BollPrice,_2nd_BollDeviation,0,y2);
       dnBand2[i]  = iCustom(NULL,_2nd_TimeFrame,indicatorFileName,"calculateValue",_2nd_BollPeriod,_2nd_BollMethod,_2nd_BollPrice,_2nd_BollDeviation,1,y2);
//---
      if(!Run_it_For_inner_BB)
        {
         NORMAL_WIDTH =0;
         WIDTH=0;
         WIDTH = upBand2[i]-dnBand2[i];
         for(n=i;n<i+Period_of_Normal_width_average+1;n++)
           {
            NORMAL_WIDTH = NORMAL_WIDTH+upBand2[n+1]-dnBand2[n+1] ;
           }
         NORMAL_WIDTH = NORMAL_WIDTH/(Period_of_Normal_width_average+1);
         if(DisplayBB_width_dots && WIDTH<NORMAL_WIDTH)     {narrower_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;  wider_NORMAL[i]=EMPTY_VALUE;} else
         if(DisplayBB_width_dots && WIDTH>NORMAL_WIDTH)    {wider_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;     narrower_NORMAL[i]=EMPTY_VALUE;}
         else {wider_NORMAL[i]=wider_NORMAL[i+1];  narrower_NORMAL[i]=narrower_NORMAL[i+1];}
         if(DisplayBB_width_dots && alertsSound_narrower_wider_Time!=Time[0] && i==0 && narrower_NORMAL[0]!= narrower_NORMAL[1])
           {
            if (alertsSound_narrower_wider) PlaySound("alert2.wav");
            alertsSound_narrower_wider_Time=Time[0];
           }
        }
      }
   }
//---
   manageAlerts();  
   return(0);         
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"lower");
         if (trend[whichBar] ==-1) doAlert(whichBar,"upper");
      }         
   }
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," "+timeFrameToString(timeFrame)+" BolliToucher price penetrated ",doWhat," band");
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"BolliToucher "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}   
 
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void OnTimer()
  {
//----
   if(DisplayBB_width_dots)
     {
      ChartRedraw();
      if(narrower_NORMAL[1]!=ChartGetDouble(0,CHART_PRICE_MIN,0) && wider_NORMAL[1]!=ChartGetDouble(0,CHART_PRICE_MIN,0) )
        {
         for(int i=0;i<Bars+1;i++)
           {
            if(narrower_NORMAL[i]!=EMPTY_VALUE) narrower_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;
            if(wider_NORMAL[i]!=EMPTY_VALUE)    wider_NORMAL[i]=ChartGetDouble(0,CHART_PRICE_MIN,0)+ iATR(NULL,0,20,0)/10.0;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| Create the button                                                |
//+------------------------------------------------------------------+
bool ButtonCreateS(string name_,string text_,int x1_,int y1_,int width_,int height_,ENUM_BASE_CORNER corner_,int font_size_)
  {
   long              chart_ID=0;               // chart's ID
   string            name=name_;//"Button";            // button name
   int               sub_window=0;             // subwindow index
   int               x=x1_;                      // X coordinate
   int               y=y1_;                      // Y coordinate
   int               width=height_;//=50;                 // button width
   int               height=width_;//=18;                // button height
   ENUM_BASE_CORNER  corner=corner_; // chart corner for anchoring
   string            text=text_;//"Button";            // text
   string            font="Arial";             // font
   int               font_size=font_size_;//8;             // font size
   color             clr=clrBlack;             // text color
   color             back_clr=clrMintCream;  // background color
   color             border_clr=clrBeige;       // border color
   bool              state=false;              // pressed/released
   bool              back=false;               // in the background
   bool              selection=false;          // highlight to move
   bool              hidden=true;              // hidden in the object list
   long              z_order=0;                 // priority for mouse click
//--- reset the error value
   ResetLastError();

   if(ObjectFind(ChartID(),name)==0) ObjectDelete(ChartID(),name);
   
//--- create the button
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
     }
//--- set button coordinates
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

